unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ComCtrls, ExtCtrls, shellapi;

type
  TWindowInfo = class
    WindowName,          // Nombre de la ventana
    WindowClass: String; // Nombre de la clase
  end;

  TMainForm = class(TForm)
    lbWinInfo: TListBox;
    hdWinInfo: THeaderControl;
    Panel1: TPanel;
    btnGetWinInfo: TButton;
    Button1: TButton;
    Label14: TLabel;
    procedure btnGetWinInfoClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lbWinInfoDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure hdWinInfoSectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure Button1Click(Sender: TObject);
    procedure Label14Click(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
function EnumWindowsProc(Hw: HWnd; AMainForm: TMainForm): Boolean; stdcall; 
var
  WinName, CName: array[0..144] of char;
  WindowInfo: TWindowInfo;
begin
  Result := True;
  GetWindowText(Hw, WinName, 144); // Obtiene el texto de la ventana actual
  GetClassName(Hw, CName, 144);    // Obtiene el nombre de la clase
  WindowInfo := TWindowInfo.Create;
  with WindowInfo do
  begin
    SetLength(WindowName, strlen(WinName));
    SetLength(WindowClass, StrLen(CName));
    WindowName := StrPas(WinName);
    WindowClass := StrPas(CName);
  end;
  MainForm.lbWinInfo.Items.AddObject('', WindowInfo);
end;

procedure TMainForm.btnGetWinInfoClick(Sender: TObject);
begin
  lbWinInfo.Clear;
  EnumWindows(@EnumWindowsProc, 0);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to lbWinInfo.Items.Count - 1 do
    TWindowInfo(lbWinInfo.Items.Objects[i]).Free
end;

procedure TMainForm.lbWinInfoDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  lbWinInfo.Canvas.FillRect(Rect);
  with TWindowInfo(lbWinInfo.Items.Objects[Index]) do
  begin
    DrawText(lbWinInfo.Canvas.Handle, PChar(WindowName),
      Length(WindowName), Rect,dt_Left or dt_VCenter);
    Rect.Left := Rect.Left + hdWinInfo.Sections[0].Width;
    DrawText(lbWinInfo.Canvas.Handle, PChar(WindowClass),
      Length(WindowClass), Rect, dt_Left or dt_VCenter);
  end;
end;

procedure TMainForm.hdWinInfoSectionResize(HeaderControl:
   THeaderControl; Section: THeaderSection);
begin
  lbWinInfo.Invalidate;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
 close;
end;

procedure TMainForm.Label14Click(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
